package cn.ch.server;

import java.io.IOException;
import java.net.Socket;

import cn.ch.servlet.Servlet;
import cn.ch.util.IOCloseUtil;

/**
 * 
 * @author 37569
 *һDispatcher൱һRequestResponse
 */
public class Dispatcher implements Runnable{
	private Request req;
	private Response rep;
	private Socket socket;
	private int code;	
	
	public Dispatcher(Socket socket){
		this.socket=socket;
		try {
			req=new Request(this.socket.getInputStream());
			rep=new Response(this.socket.getOutputStream());
		} catch (IOException e) {
			code=500;
			return;
		}
	}
	
	public void run() {
		System.out.println(req.getUrl());
		//urlͬservlet
		Servlet servlet=WebApp.getServlet(req.getUrl());
		if(servlet==null) {
			this.code = 404;
		}else {
			try {
				servlet.service(req, rep);
			} catch (Exception e) {
				this.code=500;
			}
		}
		//Ӧ͵ͻ
		rep.pushToClient(code);
		IOCloseUtil.CloseAll(socket);
	}
}
