package cn.ch.server;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

import cn.ch.servlet.Servlet;
import cn.ch.util.IOCloseUtil;

public class Server {	//serversocket͹رշ
	private ServerSocket server;
	private boolean isShutDown=false;
	public static void main(String[] args) throws IOException {
		Server server=new Server();
		server.start();
	}
	
	public void start(){
		this.start(8888);
	}
	
	public void start(int port){	//
		try {
			server=new ServerSocket(port);
			this.receive();
		} catch (IOException e) {
			isShutDown=true;
		}
	}
	
	public void receive(){
		try {
			while(!isShutDown) {
				Socket socket = server.accept();	//ͻ,ʱͻ˷Ϣȫsocket
				//Dispatcher
				Dispatcher dis=new Dispatcher(socket);
				new Thread(dis).start();
			}
		} catch (IOException e) {
			this.stop();
		}
	}
	
	
	
	public void stop() {	//ڹرշ	
		isShutDown=true;
		IOCloseUtil.CloseAll(server);
		
	}
}
